const net = require('net');
const {
    SOCKET_PROT
} = require('../const');

function startServer(callback) {
    console.info('Start createServer');
    const server = net.createServer((socket) => {
        // 创建socket服务端
        console.log(`Connect: remoteAddress[${socket.remoteAddress}] remotePort[${socket.remotePort}]`);
        socket.setEncoding('binary');
        // 监听数据
        socket.on('data', (data) => {
            data = data.replace('\n', '').trim();
            console.log('Receive data:' + data);
            callback(data, socket);
        });
        // 监听错误
        socket.on('error', (exception) => {
            console.error(`Receive error: ${exception}. End socket!`);
            socket.end();
        });
        // 监听客户端关闭事件
        socket.on('close', (data) => {
            console.log(`Client closed: ${data}`);
        });

    }).listen(SOCKET_PROT);
    //
    //服务器监听事件
    server.on('listening', () => {
        console.log("Server listening: " + server.address().port);
    });
    //服务器错误事件
    server.on("error", (exception) => {
        console.error("Server error: " + exception);
    });
}

module.exports = { startServer };